#import "TestObjects.h"

@implementation Truck

- init
{
	[super init];
	[self setMake: "Undefined"];
	[self setModel: "Undefined"];
	
	return self;
}

- setMake:(const char *) aMake
{
	strncpy(make, aMake, STRSIZE-1);
	return self;
}

- (const char *) make
{
	return (const char *) make;
}

- setModel:(const char *) aModel
{
	strncpy(model, aModel, STRSIZE-1);
	return self;
}

- (const char *) model
{
	return (const char *) model;
}

- free
{
	id		ret;
	
	ret = [super free];
	if (ret)
		return self;
	else
		return [super deallocate];
}

- read:(NXTypedStream *) typedStream
{
	[super read:typedStream];
	NXReadArray(typedStream, "c", STRSIZE, make);
	NXReadArray(typedStream, "c", STRSIZE, model);
	
	return self;	
}

- write:(NXTypedStream *) typedStream
{
	[super write:typedStream];
	NXWriteArray(typedStream, "c", STRSIZE, make);
	NXWriteArray(typedStream, "c", STRSIZE, model);
	
	return self;
}

@end

@implementation Garage

- setAVehicle: theVehicle
{
	if ([aVehicle respondsTo:
		@selector(unregisterForInvalidationNotification:)])
	{
		[aVehicle unregisterForInvalidationNotification:self];
	}
	
	if ([theVehicle respondsTo:
		@selector(registerForInvalidationNotification:)])
	{
		[theVehicle registerForInvalidationNotification:self];
	}
	
	aVehicle = theVehicle;
	
	return self;
}

- aVehicle
{
	return aVehicle;
}

- senderIsInvalid: sender
{
	aVehicle = nil;
	
	return self;
}

- free
{
	if ([aVehicle respondsTo:
		@selector(unregisterForInvalidationNotification:)])
	{
		[aVehicle unregisterForInvalidationNotification:self];
	}
	
	aVehicle = nil;
	
	return [super free];
}

- read:(NXTypedStream *) typedStream
{
	[super read:typedStream];
	aVehicle = NXReadObject(typedStream);
	
	return self;
}

- write:(NXTypedStream *) typedStream
{
	[super write:typedStream];
	NXWriteObject(typedStream, aVehicle);
	
	return self;
}

@end
